#property copyright ""
#include <stderror.mqh>
#include <stdlib.mqh>

extern double     StopLoss       =  3; 
extern double  TrSt           =  2;
extern double  trailingStep =0;
extern int Tstart =0; 
extern int Tend =6;
extern double     Speed          =  3;
extern double  timeSpeed      =  0; 
extern double Lot = 0.2;
extern double MARGIN =0;
extern int SPREAD =20;
extern int market = 1;
extern int Magic = 5555;
extern int  PipMultiplier=10;


double         Point_;
datetime       nextTime;
int            cnt, total, lastBars,i;
int            up, down, TimeSpeedUp, TimeSpeedDown;
bool           TimBoolUp,TimBoolDown, OrderSal;
double         priceUp, priceDown,profit,eee,Lotti=0,lots=0,MG,Min_Lot,Max_Lot;
datetime time;
int m;



int start()
{  
   //.........................................................
        Max_Lot = MarketInfo(Symbol(), MODE_MAXLOT);
        Min_Lot = MarketInfo(Symbol(), MODE_MINLOT);
        MG=AccountFreeMargin();
        m=MG/MarketInfo (Symbol(), MODE_MARGINREQUIRED)*MARGIN/Min_Lot;               
 //.....................................................   
    
 //.....................................................         
 
   double ask = Ask;   
   double bid = Bid;
   
   total = OrdersTotal();
   int   i, currentSymbolOrderPos = -1;
      
   for (i = 0; i < total; i++)   
   {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol())
      {

         currentSymbolOrderPos = i;
         break;
      }
   }
   
   if (currentSymbolOrderPos < 0)
   {      
      if(priceUp < ask)
      {
         up = up + 1;
         priceUp = ask;
         if(TimBoolUp == false)
         {
            TimeSpeedUp = TimeCurrent();
            TimBoolUp = true;
         }   
      }
   else
      {
        priceUp = 0;
       
        up      = 0;
        TimBoolUp = false;
        TimeSpeedUp = 0;
      }
   
      if(priceDown > ask)
      {
         down = down + 1;
         priceDown = ask;
         if(TimBoolDown == false)
         {
            TimeSpeedDown = TimeCurrent();
            TimBoolDown = true;
         }   
      }
      else
      {
         priceDown = 0;
         down      = 0;
         TimBoolDown = false;
         TimeSpeedDown = 0;   
      }
 
      if(up == Speed || down == Speed)
      {          
            openOrders();                  
      }   
   
         
      if(priceUp == 0)
      {
         priceUp   =ask;         
      }
      if(priceDown == 0)
      {        
         priceDown = ask;
      }
   }   
else 
   {
      OrderSelect(currentSymbolOrderPos, SELECT_BY_POS, MODE_TRADES);
      
      if (OrderType() == OP_SELL&&OrderMagicNumber()==Magic && OrderProfit()>0 &&MarketInfo(Symbol(), MODE_STOPLEVEL)>TrSt*PipMultiplier)
      OrderClose (OrderTicket(),OrderLots(),Ask,5,CLR_NONE);  
      if (OrderType() == OP_BUY &&OrderMagicNumber()==Magic&& OrderProfit()>0 &&MarketInfo(Symbol(), MODE_STOPLEVEL) >TrSt*PipMultiplier)
      OrderClose (OrderTicket(),OrderLots(),Bid,5,CLR_NONE); 
      if (OrderType() == OP_SELL &&OrderStopLoss()==0&&OrderMagicNumber()==Magic)
      OrderModify(OrderTicket(),OrderOpenPrice(),Ask + StopLoss*Point*PipMultiplier,0, 0, CLR_NONE);
      if (OrderType() == OP_BUY  &&OrderStopLoss()==0&&OrderMagicNumber()==Magic)
      OrderModify(OrderTicket(),OrderOpenPrice(),Bid - StopLoss*Point*PipMultiplier,0, 0, CLR_NONE);

      if (OrderType() == OP_BUY)
      {
         if(OrderSal == true)
         {
            OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Bid - StopLoss*Point*PipMultiplier,Digits),0, 0, Red);
            PlaySound("ok.wav");
            OrderSal = false;
         }
         if (Bid-OrderOpenPrice()>TrSt*Point*PipMultiplier)
         {
            if (OrderStopLoss()<Bid -(TrSt + trailingStep)*Point*PipMultiplier )
            {
              OrderModify(OrderTicket(),OrderOpenPrice(),Bid - (TrSt)*Point*PipMultiplier,0, 0, Red);
              PlaySound("ok.wav");
            }
         }        
      }
      if (OrderType() == OP_SELL)
      {   
         if(OrderSal == true)
         {
            OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Ask + StopLoss*Point*PipMultiplier, Digits),0, 0, Red);
            PlaySound("ok.wav");
            OrderSal = false;
         }    
         if (OrderOpenPrice()-Ask > TrSt*Point*PipMultiplier)
         {
           if (OrderStopLoss() > Ask +(TrSt + trailingStep)*Point*PipMultiplier ) 
           {
              OrderModify(OrderTicket(),OrderOpenPrice(),Ask + (TrSt)*Point*PipMultiplier,0, 0, Red);
              PlaySound("ok.wav");
           }
         }            
      }
   }   
   return(0);
}

void openOrders()
{  
   double V = iWPR(NULL,1,5,0);
   double W = iWPR(NULL,1,5,0);
   double W1 = iWPR(NULL,1,5,1);
   if(SPREAD<MarketInfo(Symbol(), MODE_SPREAD))return(0);   
   int try;
   double s;
   if(up < down)
   {
          if(TimeCurrent() - TimeSpeedDown <= timeSpeed&&V>-100&&W<W1&&TimeCurrent()>Time[0]+Tstart&&TimeCurrent()<Time[0]+Tend)
      {           
         RefreshRates(); 
         for(try = 1; try <= 2; try++)
         {   
           
           if(market > 0 )s = Ask+StopLoss*Point*PipMultiplier;
           if(market == 0 )s = 0;
           if(MARGIN==0)Lotti= Lot;
           if(MARGIN>0)Lotti = m*Min_Lot;
           if(Lotti < Min_Lot)Lotti=Min_Lot;
           if(Lotti > Max_Lot)Lotti=Max_Lot;
           OrderSend(Symbol(),OP_SELL,Lotti,Bid,10,s,0 ,"",Magic,0,Red);
           PlaySound("alert2.wav");
           return(0);              
         }
      }   
   }
    else 
   {  
          if(TimeCurrent() - TimeSpeedUp <= timeSpeed&&V<0&&W>W1&&TimeCurrent()>Time[0]+Tstart&&TimeCurrent()<Time[0]+Tend)
      {           
           RefreshRates();    
         for(try = 1; try <= 2; try++)//lots
         {  
            
            if(market > 0 )s = Bid-StopLoss*Point*PipMultiplier;
            if(market == 0 )s = 0;            
            if(MARGIN==0)Lotti= Lot;
            if(MARGIN>0)Lotti = m*Min_Lot;  
            if(Lotti < Min_Lot)Lotti=Min_Lot; 
            if(Lotti > Max_Lot)Lotti=Max_Lot;    
            OrderSend(Symbol(),OP_BUY,Lotti,Ask,10,s,0, "", Magic, 0, Green);
            PlaySound("alert.wav");
            return(0);
              
         }
                
      }   
   }    
   priceUp   = 0;
   priceDown = 0;
   up        = 0;
   down      = 0;
   TimBoolUp = false;
   TimBoolDown = false;
   TimeSpeedUp = 0;
   TimeSpeedDown = 0;       
}

int init()
{

   return(0);
}

int deinit()
{
   return(0);
}





